app.controller('programController',['$scope','storageService',
    function ($scope, storageService) { 
        $scope.events = storageService.getItem('events');
        $scope.venues = storageService.getItem('venues');
        $scope.days = storageService.getItem('days');
        
        angular.element(document).ready(function () {
            var activeOne = "thursday";
            var myScroller = new IScroll('#wrapper', {
                eventPassthrough: true,
                scrollX: true,
                scrollY: false,
                preventDefault: false,
                startX: smallestMarginLeft("thursday")
            });
            function smallestMarginLeft(divId){
                var elm = document.getElementById(divId);
                var elementArray = elm.getElementsByClassName('timeline-event');
                var smallestMargin = 2000;
                for(var i = 0; i < elementArray.length; i++){
                    if(parseInt(elementArray[i].style.marginLeft, 10) < smallestMargin){
                        smallestMargin = parseInt(elementArray[i].style.marginLeft, 10);
                    }
                }
                return smallestMargin * -1;
            };

            $scope.setActive = function(venueId){
                activeOne = venueId;
                myScroller.scrollTo(smallestMarginLeft(venueId), 0, 500, IScroll.utils.ease.elastic);
            };
            $scope.isActive = function(dayName){
                return activeOne === dayName;
            };
        });

        // Check for updates and update data when done
        storageService.dataUpdated('events').then(function(results){
            if(results.data !== localStorage.getItem('events' + '_updated')){
                storageService.updateData('events').then(function(){
                    $scope['events'] = storageService.getItem('events');
                });
            } 
        });
        
        // Check for updates and update data when done
        storageService.dataUpdated('venues').then(function(results){
            if(results.data !== localStorage.getItem('venues' + '_updated')){
                storageService.updateData('venues').then(function(){
                    $scope['events'] = storageService.getItem('venues');
                });
            } 
        });
        
        $scope.matchVenue = function (venue){
            return function(event){
                return event.venue_id.match(venue.venue_id);
            };
        };
        
        $scope.matchDay = function (day){
            return function(event){
                return event.event_day.match(day);
            };
        };
    }
]);